-- LBP.lua


		function deepcopy(t)
			if type(t) ~= 'table' then return t end
			local mt = getmetatable(t)
			local res = {}
			for k,v in pairs(t) do
				if type(v) == 'table' then
					v = deepcopy(v)
				end
				res[k] = v
			end
			setmetatable(res,mt)
			return res
		end

-- Variablen
local NameOfProject = "Lazy Boss Preparation"										-- Name des Projekts
local EventFrame														-- Frame, das auf Events reagiert
local TimeSinceLastUpdate = 0.0
local UpdateFrequency = 1;
local Layout
local LBPObject													-- dummy fuer die Objects
local LBPMainframe 												-- dummy fuer das Hauptframe
local LBPConfigframe 
local LBPOnUpdateframe
local showmode = false;

LBP = {}


LBP_DB = {															-- default Konfiguration,
																		-- wird whrend des Variabelnladens
																		-- ueberschrieben

};


local debugging = false


function LBP.echo( self, msg )												-- Beginn echo
																		-- Einfache Routine zur Ausgabe von Nachrichten
	if not msg then
		msg = "Error: nil"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject..":|r "..msg)

end	

																-- Ende echo

																
																
function LBP.help( self )															-- Beginn help
	LBP.echo("LBP Hilfe")

end	

function LBP.CreateConfig(self)
	
	
	local frame = LBP:CreateFrame("frame", "LBPConfigFrame", UIParent, nil, "CENTER", UIParent, "CENTER", -300, 0, 300, 500)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:Show()
	local editcard = LBP:CreateFrame("frame", "editcard", frame, nil, "TOP", frame, "TOP", 0, -10, 1, 1)

		
	frame.button = CreateFrame("BUTTON", "Button_CloseConfig", frame, "UIPanelButtonTemplate")
		frame.button:SetText("X")
		frame.button:SetWidth(30)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
						LBPMainFrame.zone = nil
		LBPMainFrame.subzone = nil
				showmode = false;
				frame:Hide()
				LBPMainframe:Show()
			end)
		frame.button:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)


	frame.button = CreateFrame("BUTTON", "Button_CreateCard", frame, "UIPanelButtonTemplate")
		frame.button:SetText("Create Card")
		frame.button:SetWidth(80)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
		
	if not InCombatLockdown() and GetSubZoneText() ~= "" then
		LBPMainFrame.zone = nil
		LBPMainFrame.subzone = nil
		local id, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
		card = {};
		card["Name"] = GetSubZoneText();
		
		card["Talents"] = LBP:GetTalentString();
		card["Spec"] = specname;
		card["Glyphs"] = {};
		for index,value in pairs(LBP:GetGlyphTable()) do
			card["Glyphs"][value[2]] = value[1];
		end
		card["Macro1"] = "/script print(\"LBP Macro #1\")";
		card["Macro2"] = "/script print(\"LBP Macro #2\")";
		card["Macro3"] = "/script print(\"LBP Macro #3\")";
		card["Macro4"] = "/script print(\"LBP Macro #4\")";
		
		if not LBP_DB[GetZoneText()] then LBP_DB[GetZoneText()] = {} end
		if not LBP_DB[GetZoneText()][GetSubZoneText()] then LBP_DB[GetZoneText()][GetSubZoneText()] = {} end
		
		local id = time()
		
		LBP_DB[GetZoneText()][GetSubZoneText()][id] = card;
	
	
		editcard:Hide()
		editcard = nil;
		
		editcard = LBP:CreateEditCard( frame, GetZoneText(), GetSubZoneText(), id)
		
		editcard:SetPoint("LEFT", frame, "RIGHT")
		editcard:Show()

	end	
	frame:Build(id)	
			end)
		frame.button:SetPoint("TOP", frame, "TOP", 0, 0)
		
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, -10, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
	
	
	textbox:SetText("Config")
	

	local list = LBP:CreateFrame("frame", "Liste", frame, nil, "TOP", textbox, "BOTTOM", 0, 0, 1, 1)

function frame:Build(highlight)	

	list:Hide()
	list = nil;
	list = LBP:CreateFrame("frame", "Liste", frame, nil, "TOP", textbox, "BOTTOM", 0, 0, 1, 1)
	
	local textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", textbox, "BOTTOM", 0, 0, 280, 1, "LEFT", "TOP", 1, 1, 1, 1)
		
	for zone,value in pairs(LBP_DB) do
		textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOP", textbox, "BOTTOM", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
		textbox:SetText("|c00aaaaaa"..zone.."|r")
		
		for subzone,value in pairs(LBP_DB[zone]) do
		
			textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOP", textbox, "BOTTOM", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
			textbox:SetText("|c00aaaaaa  " .. subzone.."|r")
			
			for id, card in pairs(LBP_DB[zone][subzone]) do

			textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", textbox, "BOTTOM", 0, 0, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
			
			if id == highlight then
				textbox:SetText("|c00ffffff >  " .. card["Name"].."|r")
			else
				textbox:SetText("|c00ffffff    " .. card["Name"].."|r")
			end


--			frame:SetText(frame:GetText() .. "|c00aaaaaa  " .. value["Name"].."|r\n")
				--frame:SetText(frame:GetText() .. "|c00aaaaaa    " .. index.."|r\n")
				
				
				
	list.button = CreateFrame("BUTTON", "Test", list, nil)
		list.button:SetText("Test")
		list.button:SetWidth(280)
		list.button:SetHeight(30)
		list.button:SetPoint('TOP', textbox, 'TOP', 0, 0)
		list.button:SetScript("OnClick", 
			function(self) 
			
			frame:Build(id)
	if not InCombatLockdown() and GetSubZoneText() ~= "" then
		editcard:Hide()
		editcard = nil;
		
		editcard = LBP:CreateEditCard( frame, zone, subzone, id)
		
		editcard:SetPoint("LEFT", frame, "RIGHT")
		editcard:Show()

	end	
	
	
	
	
			end)
			
			end
			end
	end
	
	return
			
end

		
			
			

	local oldShow = frame.Show;
	
	frame.Show = function(...)
		local id = nil;
		if LBP_DB[GetZoneText()] then
			if LBP_DB[GetZoneText()][GetSubZoneText()] then
				for index in pairs (LBP_DB[GetZoneText()][GetSubZoneText()]) do
				id = index;
					editcard:Hide()
					editcard = nil;

					editcard = LBP:CreateEditCard( frame, GetZoneText(), GetSubZoneText(), index)
				
					editcard:SetPoint("LEFT", frame, "RIGHT")
					editcard:Show()
					
				end
				
			end
		end
		
		frame:Build(id)
		
		
		oldShow(...)
	end

	
	frame:Hide()
	
	return frame
end



function LBP.CreateCard( self, parent, zone, subzone, id, n)
	local frame = LBP:CreateFrame("frame", "LBPMainFrame", parent, nil, "CENTER", parent, "CENTER", 0, 0, 300, 450)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	--frame:Show()
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, -10, 300, 50, "CENTER", "TOP", 1, 1, 1, 1)
	
	frame.timeUpdated = 0;
	
	frame.Talents = {};
	
	for a=1,3*6 do
		local _, iconTexture = GetTalentInfo(a)
		
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, frame, nil, "CENTER", textbox, "BOTTOM", mod(a-1,3)*32-120, -ceil(a/3)*32,  32, 32)
		
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..a)
			tmpframe.texture:SetTexture(iconTexture)
			tmpframe.texture:SetAllPoints()
			--texture:SetPoint("TOPLEFT" , tmpframe , "TOPLEFT", mod(a-1,3)*32-120, -ceil(a/3)*32)


		frame.Talents[a] = tmpframe;
		frame.Talents[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Talents[a]); GameTooltip:SetTalent(a); GameTooltip:Show(); end)
		frame.Talents[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		

			--tmpframe:SetBackdrop({
--				bgFile = iconTexture,
				--tile = false, tileSize = height, edgeSize = 0,
				--insets = { left = 0, right = 0, top = 0, bottom = 0 }
			--})
		--frame.Talents[a] = tmpframe;
		

	end

	
	function frame:SetTalents(tmp)
		
		for a = 1,3*6 do
			local name, iconTexture, _, _, isSet = GetTalentInfo(a)
				
				if isSet then
					frame.Talents[a].texture:SetDesaturated(0);
					frame.Talents[a].texture:SetVertexColor(1,0.2,0.2,1);
					frame.Talents[a]:SetHeight(32)
					frame.Talents[a]:SetWidth(32)
				else
					frame.Talents[a].texture:SetDesaturated(1);
					frame.Talents[a]:SetHeight(24)
					frame.Talents[a]:SetWidth(24)
				end
		end
		
		for a =1,6 do
			--print(GetTime() .." "..tmp)
			--print(tonumber(string.sub(tmp,a,a)))
			b = tonumber(string.sub(tmp,a,a));

				frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
				frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
				frame.Talents[(a-1)*3+b+1].texture:SetHeight(32)
				frame.Talents[(a-1)*3+b+1].texture:SetWidth(32)
		end
	end
	
		
	frame.Glyph = {};
	
	for a=1,6 do
	--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "LEFT", frame, "RIGHT", -64+floor((a-1)/2)*64, -64*mod(a,2), 64-16*mod(a,2), 64-16*mod(a,2))
	local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "CENTER", textbox, "BOTTOM", cos(a*60-30)*12*(5-mod(a,2))+50, sin(a*60-30)*12*(5-mod(a,2))-120, 48-8*mod(a,2), 48-8*mod(a,2))
	
	
		function tmpframe:SetGlyph(tmp, tmp2)
			tmpframe:SetBackdrop({
				bgFile = tmp,
				tile = false, tileSize = height, edgeSize = 0,
				insets = { left = 0, right = 0, top = 0, bottom = 0 }
			})
			if tmp2 then
				tmpframe:SetBackdropColor(1,1,1,1);
			else
				tmpframe:SetBackdropColor(1,0.2,0.2,1);
			end
		end
	frame.Glyph[a] = tmpframe;
	end


	
	
	
	
	local macroframe1 = LBP:CreateFrame("frame", "Macroframe1", frame, nil, "CENTER", textbox, "BOTTOM", -36-64-8, -250, 64, 64);
	local macroframe2 = LBP:CreateFrame("frame", "Macroframe2", frame, nil, "CENTER", textbox, "BOTTOM", -36, -250, 64, 64);
	local macroframe3 = LBP:CreateFrame("frame", "Macroframe3", frame, nil, "CENTER", textbox, "BOTTOM", 36, -250, 64, 64);
	local macroframe4 = LBP:CreateFrame("frame", "Macroframe4", frame, nil, "CENTER", textbox, "BOTTOM", 36+64+8, -250, 64, 64);



		
	frame.button = CreateFrame("BUTTON", "OkayNTC", frame, "UIPanelButtonTemplate")
		frame.button:SetText("Edit")
		frame.button:SetWidth(180)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
				print("hier sollte editiert werden")
				parent:Hide()
			end)
		frame.button:SetPoint('TOP', textbox, 'BOTTOM', 0, -300)

	if n>1 then

	frame:SetScript("OnMouseUp", 
			function(self) 
				for index,value in pairs(LBP_DB[zone][subzone]) do
					value["active"] = false
				end
				LBP_DB[zone][subzone][id]["active"] = true;
				
				for index,value in pairs(parent.cards) do
					value.timeUpdated = 0;
				end
				--frame.timeUpdated = 0;
			end)
	

	end
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	local darkframe = LBP:CreateFrame("frame", "Darkframe", frame, nil, "CENTER", frame, "CENTER", 0, 0, 300, 450)
		darkframe:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark"});
		darkframe:SetBackdropColor(1, 1, 1 , .5)
		darkframe:SetFrameLevel(100)
		darkframe:Hide()

		
		
		
		
		
		
		
		
		
		
		
		
local OnUpdate = function(elapsed)										-- Beginn OnUpdate	
	--print(id .." "..TimeSinceLastUpdate)

	if time()-frame.timeUpdated > UpdateFrequency then
		if not InCombatLockdown() and GetSubZoneText() ~= "" then
		
		local specid, spec, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
		
		local prepared = true;

		
		local card = deepcopy(LBP_DB[zone][subzone][id]);
		
		if n == 1 then card["active"] = true end
		
		if n>1 and not card["active"] then
			frame:SetScale(0.8)
		else 
			frame:SetScale(1)
		end
		
		textbox:SetText(card["Name"].."\n\n");
		--print (GetSubZoneText());
		s = LBP:GetTalentString();
--[[			
		if card["Talents"] == s then
			textbox:SetText(textbox:GetText().."Talents: " .."|cff00FF00"..card["Talents"].."|r".."\n");
		else
			textbox:SetText(textbox:GetText().."Talents: " .."|cffFF0000"..card["Talents"].."|r".."\n");
			prepared = false;
		end
		--print("Talents: " ..s);
		
--]]
		

		if card["Spec"] == spec then
			textbox:SetText(textbox:GetText().."Spec: " .."|cff00FF00"..card["Spec"].."|r".."\n");
		else
			textbox:SetText(textbox:GetText().."Spec: " .."|cffFF0000"..card["Spec"].."|r".."\n");
			prepared = false;
		end
		--print("Spec: "..name);
		
		frame:SetTalents(card["Talents"])
		
		local g = LBP:GetGlyphTable(); -- die drin sind
		

		
		
		local copy = deepcopy(card["Glyphs"])-- Die drin sein sollen
		
		--for index,value in pairs(LBP_DB[subzone]["Glyphs"]) do
--			LBPMainframe:SetText(LBPMainframe:GetText()..LBP_DB[subzone]["Glyphs"][index].." "..index.."\n");
		--end

	
		-- berprfen welche richtig sind
		for index,value in pairs(g) do
			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(value[2])
			--frame.Glyph[index]:SetGlyph(icon, false)
			
			
			for index2 in pairs(copy) do
	
				if value[2] == tonumber(index2) then
					frame.Glyph[index]:SetGlyph(icon, true)
					frame.Glyph[index]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[index]); GameTooltip:SetSpellByID(value[2]); GameTooltip:Show(); end)
					frame.Glyph[index]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
					g[index] = 1;
					copy[index2] = {};
				end
			end		
	
		end
		
		for index,value in pairs(g) do
			if g[index] ~= 1 then
				for index2 in pairs(copy) do
					if copy[index2] == value[1] then
						local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(index2)
						frame.Glyph[index]:SetGlyph(icon, false)
						frame.Glyph[index]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[index]); GameTooltip:SetSpellByID(index2); GameTooltip:Show(); end)
						frame.Glyph[index]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
						copy[index2] = {};
						prepared = false;
						break
					end
				end
			end
		end

		
		if not card["Macro1"] then card["Macro1"] = "/script print(\"LBP: Macro #1\")"; end
		if not card["Macro2"] then card["Macro2"] = "/script print(\"LBP: Macro #2\")"; end
		if not card["Macro3"] then card["Macro3"] = "/script print(\"LBP: Macro #3\")"; end
		if not card["Macro4"] then card["Macro4"] = "/script print(\"LBP: Macro #4\")"; end
	
		local name, iconTexture, body = GetMacroInfo("LBP Macro 1");
			macroframe1:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe1:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro1"]); GameTooltip:Show(); end)
			macroframe1:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
			
		local name, iconTexture, body = GetMacroInfo("LBP Macro 2");
			macroframe2:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe2:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro2"]); GameTooltip:Show(); end)
			macroframe2:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)

		local name, iconTexture, body = GetMacroInfo("LBP Macro 3");
			macroframe3:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe3:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro3"]); GameTooltip:Show(); end)
			macroframe3:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)

		local name, iconTexture, body = GetMacroInfo("LBP Macro 4");
			macroframe4:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe4:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro4"]); GameTooltip:Show(); end)
			macroframe4:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)			
			
		if card["active"] then
			EditMacro(GetMacroIndexByName("LBP Macro 1"),"LBP Macro 1",nil, card["Macro1"])
			EditMacro(GetMacroIndexByName("LBP Macro 2"),"LBP Macro 2",nil, card["Macro2"])
			EditMacro(GetMacroIndexByName("LBP Macro 3"),"LBP Macro 3",nil, card["Macro3"])
			EditMacro(GetMacroIndexByName("LBP Macro 4"),"LBP Macro 4",nil, card["Macro4"])
		else
			macroframe1:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK", tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe2:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK", tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe3:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK", tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe4:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK", tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
		end
		
		
		if card["active"] then
			darkframe:Hide()
		else
			darkframe:Show()
		end
		
		if prepared then
			frame:SetBackdropColor(0, .3, 0 , 1)
		else
			frame:SetBackdropColor(0, 0, 0 , 1)
		end

		
	end
	

	
	
	--print(GetTime().." OnUpdate")
			
    frame.timeUpdated = time();
  end

end	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	frame:SetScript("OnUpdate", function(self, event, ... ) OnUpdate(event, ...) end)
	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		TimeSinceLastUpdate = UpdateFrequency;
		oldShow(...)
	end
	
	frame:Hide()
	return frame
end


function LBP.CreateEditCard( self, parent, zone, subzone, id)

	local card = deepcopy(LBP_DB[zone][subzone][id]);

	local frame = LBP:CreateFrame("frame", "LBPMainFrame", parent, nil, "CENTER", parent, "CENTER", 0, 0, 600, 450)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdropColor(0, 0, 0 , 1)
	
	--frame:Show()
	local editname = LBP:CreateFrame("EditBox", "LBPEditBox", frame, "InputBoxTemplate", "TOPLEFT", frame, "TOPLEFT", 20,0, 200, 50)
		editname:SetAutoFocus(false) 
		editname:SetJustifyH("CENTER");
		editname:SetText(LBP_DB[zone][subzone][id]["Name"])
	
		editname:SetScript("OnTextChanged",
			function (self)
				LBP_DB[zone][subzone][id]["Name"] = editname:GetText()
				parent:Build(id)
			end)
			
		editname:Show()
		
	
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", -150, -50, 300, 20, "CENTER", "TOP", 1, 1, 1, 1)
	
	frame.timeUpdated = 0;
	
	frame.Talents = {};
	
	for a=1,3*6 do
		local _, iconTexture = GetTalentInfo(a)
		
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, frame, nil, "CENTER", textbox, "BOTTOM", mod(a-1,3)*32-120, -ceil(a/3)*32,  32, 32)
		
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..a)
			tmpframe.texture:SetTexture(iconTexture)
			tmpframe.texture:SetAllPoints()
			--texture:SetPoint("TOPLEFT" , tmpframe , "TOPLEFT", mod(a-1,3)*32-120, -ceil(a/3)*32)


		frame.Talents[a] = tmpframe;
		frame.Talents[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Talents[a]); GameTooltip:SetTalent(a); GameTooltip:Show(); end)
		frame.Talents[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		

			--tmpframe:SetBackdrop({
--				bgFile = iconTexture,
				--tile = false, tileSize = height, edgeSize = 0,
				--insets = { left = 0, right = 0, top = 0, bottom = 0 }
			--})
		--frame.Talents[a] = tmpframe;
		

	end

	
	function frame:SetTalents(tmp)
		
		for a = 1,3*6 do
			local name, iconTexture, _, _, isSet = GetTalentInfo(a)
				
				if isSet then
					frame.Talents[a].texture:SetDesaturated(0);
					frame.Talents[a].texture:SetVertexColor(1,0.2,0.2,1);
					frame.Talents[a]:SetHeight(32)
					frame.Talents[a]:SetWidth(32)
				else
					frame.Talents[a].texture:SetDesaturated(1);
					frame.Talents[a]:SetHeight(24)
					frame.Talents[a]:SetWidth(24)
				end
		end
		
		for a =1,6 do
			--print(GetTime() .." "..tmp)
			--print(tonumber(string.sub(tmp,a,a)))
			b = tonumber(string.sub(tmp,a,a));

				frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
				frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
				frame.Talents[(a-1)*3+b+1].texture:SetHeight(32)
				frame.Talents[(a-1)*3+b+1].texture:SetWidth(32)
		end
	end
	
		
	frame.Glyph = {};
	
	for a=1,6 do
	--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "LEFT", frame, "RIGHT", -64+floor((a-1)/2)*64, -64*mod(a,2), 64-16*mod(a,2), 64-16*mod(a,2))
	local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "CENTER", textbox, "BOTTOM", cos(a*60-30)*12*(5-mod(a,2))+50, sin(a*60-30)*12*(5-mod(a,2))-120, 48-8*mod(a,2), 48-8*mod(a,2))
	
	
		function tmpframe:SetGlyph(tmp, tmp2)
			tmpframe:SetBackdrop({
				bgFile = tmp,
				tile = false, tileSize = height, edgeSize = 0,
				insets = { left = 0, right = 0, top = 0, bottom = 0 }
			})
			if tmp2 then
				tmpframe:SetBackdropColor(1,1,1,1);
			else
				tmpframe:SetBackdropColor(1,0.2,0.2,1);
			end
		end
	frame.Glyph[a] = tmpframe;
	end
	
		frame.button2 = CreateFrame("BUTTON", "SetThisNTC", frame, "UIPanelButtonTemplate")
		frame.button2:SetText("Change T/G/S to actual T/G/S")
		frame.button2:SetWidth(180)
		frame.button2:SetHeight(30)
		frame.button2:SetScript("OnClick", 
			function(self) 
				local id, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
				if not LBP_DB[zone] then LBP_DB[zone] = {}; end
				if not LBP_DB[zone][subzone] then LBP_DB[zone][subzone] = {}; end
				LBP_DB[zone][subzone][id] = {};
				LBP_DB[zone][subzone][id]["Talents"] = LBP:GetTalentString();
				LBP_DB[zone][subzone][id]["Spec"] = specname;
				LBP_DB[zone][subzone][id]["Glyphs"] = {};
				for index,value in pairs(LBP:GetGlyphTable()) do
					LBP_DBLBP_DB[zone][subzone][id]["Glyphs"][value[2]] = value[1];
				end
			end)
		frame.button2:SetPoint('TOP', textbox, 'BOTTOM', 0, -300)
		
	frame.button3 = CreateFrame("BUTTON", "RemoveNTC", frame, "UIPanelButtonTemplate")
		frame.button3:SetText("Remove this card")
		frame.button3:SetWidth(180)
		frame.button3:SetHeight(30)
		frame.button3:SetScript("OnClick", 
			function(self) 
				frame:Hide()
				LBP_DB[zone][subzone][id] = nil;
				local n = 0;
				for index in pairs(LBP_DB[zone][subzone]) do
					n=n+1;
				end
				if n == 0 then LBP_DB[zone][subzone] = nil; end
				
				n = 0;
				for index in pairs(LBP_DB[zone]) do
					n=n+1;
				end
				if n == 0 then LBP_DB[zone] = nil; end
				parent:Build()	
			end)
		frame.button3:SetPoint('TOP', frame.button2, 'BOTTOM', 0, -8)


		if GetZoneText() ~= zone or GetSubZoneText() ~= subzone then	
		
	frame.button4 = CreateFrame("BUTTON", "CopyNTC", frame, "UIPanelButtonTemplate")
		frame.button4:SetText("Copy this Template to this zone")
		frame.button4:SetWidth(180)
		frame.button4:SetHeight(30)
		frame.button4:SetScript("OnClick", 
			function(self) 
				if not LBP_DB[GetZoneText()] then LBP_DB[GetZoneText()] = {}; end
				if not LBP_DB[GetZoneText()][GetSubZoneText()] then LBP_DB[GetZoneText()][GetSubZoneText()] = {}; end
				newid = time()
				LBP_DB[GetZoneText()][GetSubZoneText()][newid] = card;
				parent:Build(newid)
			end)
		frame.button4:SetPoint('TOP', textbox, 'BOTTOM', 300, -300)

end		
	
	
	local macroframe1 = LBP:CreateFrame("frame", "Macroframe1", frame, nil, "CENTER", textbox, "BOTTOM", -36-64-8, -250, 64, 64);
	local macroframe2 = LBP:CreateFrame("frame", "Macroframe2", frame, nil, "CENTER", textbox, "BOTTOM", -36, -250, 64, 64);
	local macroframe3 = LBP:CreateFrame("frame", "Macroframe3", frame, nil, "CENTER", textbox, "BOTTOM", 36, -250, 64, 64);
	local macroframe4 = LBP:CreateFrame("frame", "Macroframe4", frame, nil, "CENTER", textbox, "BOTTOM", 36+64+8, -250, 64, 64);


	
	

	local textbox1 = LBP:CreateFontString(frame, "textbox1","ARTWORK", "GameFontNormal", "TOP", frame, "TOP", 150, -10, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	textbox1:SetText("Macro 1")
	


	
	local rahmen = LBP:CreateFrame("frame", "Rahmen", frame, nil, "TOP", textbox1, "BOTTOM", 0, 0, 280, 80)
			rahmen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	local tmpframe = LBP:CreateFrame("ScrollFrame", "EditFrame", rahmen, "UIPanelScrollFrameTemplate", "TOPLEFT", rahmen, "TOPLEFT", 8, -6, 280-8-8, 160-8-8)

--			tmpframe:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			tmpframe.name = "Scrollframe";
			
	
	local editframe1 = CreateFrame("EditBox", "LBPEditBox", tmpframe) --, "InputBoxTemplate")
		editframe1:SetPoint("TOPLEFT", tmpframe, "TOPLEFT", 8,-6)
		editframe1:SetPoint("BOTTOMRIGHT", tmpframe, "BOTTOMRIGHT", -8,6)
		
		editframe1:SetScript("OnEscapePressed", function(self) EditBox_ClearFocus(self) end)
		editframe1:SetScript("OnEditFocusLost", function(self) EditBox_ClearHighlight(self); end)
		editframe1:SetScript("OnEditFocusGained", function(self) EditBox_HighlightText(self); end)

		
		
	editframe1:SetFont("Fonts\\ARIALN.TTF",14,"none")
	editframe1:SetMultiLine(true)
	--editframe1:SetAllPoints();
	--editframe1:SetHeight(60)
	editframe1:SetAutoFocus(false) 
	editframe1:SetJustifyH("LEFT");
	editframe1:SetJustifyV("CENTER");
	editframe1:SetText(LBP_DB[zone][subzone][id]["Macro1"])
	editframe1.h = tmpframe:GetVerticalScroll();
	
	editframe1:SetScript("OnTextChanged",
		function (self)
			tmpframe:SetVerticalScroll(tmpframe:GetVerticalScroll() + tmpframe:GetVerticalScrollRange() -editframe1.h);
			editframe1.h = tmpframe:GetVerticalScroll()

			--print(tmpframe:GetVerticalScrollRange() .." "..tmpframe:GetVerticalScroll())
			tmpframe:UpdateScrollChildRect()
			local text = editframe1:GetText(); if string.len(text)>255 then editframe1:SetText(string.sub(text,1,255)) end  LBP_DB[zone][subzone][id]["Macro1"] = editframe1:GetText() EditMacro(GetMacroIndexByName("LBP Macro 1"),"LBP Macro 1",nil, editframe1:GetText())
		end)
	
	editframe1:Show()
	
	
	tmpframe:SetSize(280-8-8-30, 80-8-8)
	editframe1:SetSize(280-8-8-30,10)
	tmpframe:SetScrollChild(editframe1)
	--tmpframe:SetSize(280-8-8-20, 120-8-8)
		--editframe1:SetPoint("TOPLEFT", tmpframe, "TOPLEFT", 8,-6)
		--editframe1:SetPoint("TOPRIGHT", tmpframe, "TOPRIGHT", -8,-6)
		--editframe1:SetSize(280-8-8,300)
	

	--editframe1:EnableMouseWheel(true);


	
	
	

	local textbox2 = LBP:CreateFontString(frame, "textbox2","ARTWORK", "GameFontNormal", "TOP", frame, "TOP", 150, -150, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	textbox2:SetText("Macro 2")
	


	
	local rahmen = LBP:CreateFrame("frame", "Rahmen", frame, nil, "TOP", textbox2, "BOTTOM", 0, 0, 280, 80)
			rahmen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	local tmpframe = LBP:CreateFrame("ScrollFrame", "editframe2", rahmen, "UIPanelScrollFrameTemplate", "TOPLEFT", rahmen, "TOPLEFT", 8, -6, 280-8-8, 160-8-8)

--			tmpframe:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			tmpframe.name = "Scrollframe";
			
	
	local editframe2 = CreateFrame("EditBox", "LBPEditBox", tmpframe) --, "InputBoxTemplate")
		editframe2:SetPoint("TOPLEFT", tmpframe, "TOPLEFT", 8,-6)
		editframe2:SetPoint("BOTTOMRIGHT", tmpframe, "BOTTOMRIGHT", -8,6)
		
		editframe2:SetScript("OnEscapePressed", function(self) EditBox_ClearFocus(self) end)
		editframe2:SetScript("OnEditFocusLost", function(self) EditBox_ClearHighlight(self); end)
		editframe2:SetScript("OnEditFocusGained", function(self) EditBox_HighlightText(self); end)

		
		
	editframe2:SetFont("Fonts\\ARIALN.TTF",14,"none")
	editframe2:SetMultiLine(true)
	--editframe2:SetAllPoints();
	--editframe2:SetHeight(60)
	editframe2:SetAutoFocus(false) 
	editframe2:SetJustifyH("LEFT");
	editframe2:SetJustifyV("CENTER");
	editframe2:SetText(LBP_DB[zone][subzone][id]["Macro2"])
	editframe2.h = tmpframe:GetVerticalScroll();
	
	editframe2:SetScript("OnTextChanged",
		function (self)
			tmpframe:SetVerticalScroll(tmpframe:GetVerticalScroll() + tmpframe:GetVerticalScrollRange() -editframe2.h);
			editframe2.h = tmpframe:GetVerticalScroll()

			--print(tmpframe:GetVerticalScrollRange() .." "..tmpframe:GetVerticalScroll())
			tmpframe:UpdateScrollChildRect()
			local text = editframe2:GetText(); if string.len(text)>255 then editframe2:SetText(string.sub(text,1,255)) end  LBP_DB[zone][subzone][id]["Macro2"] = editframe2:GetText() EditMacro(GetMacroIndexByName("LBP Macro 2"),"LBP Macro 2",nil, editframe2:GetText())
		end)
	
	editframe2:Show()
	
	
	tmpframe:SetSize(280-8-8-30, 80-8-8)
	editframe2:SetSize(280-8-8-30,10)
	tmpframe:SetScrollChild(editframe2)
	--tmpframe:SetSize(280-8-8-20, 120-8-8)
		--editframe2:SetPoint("TOPLEFT", tmpframe, "TOPLEFT", 8,-6)
		--editframe2:SetPoint("TOPRIGHT", tmpframe, "TOPRIGHT", -8,-6)
		--editframe2:SetSize(280-8-8,300)
	

	--editframe2:EnableMouseWheel(true);

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	

local OnUpdate = function(elapsed)										-- Beginn OnUpdate	
	--print(id .." "..TimeSinceLastUpdate)

	if time()-frame.timeUpdated > UpdateFrequency then
		if not InCombatLockdown() and GetSubZoneText() ~= "" then
		
		local specid, spec, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
		
		local prepared = true;


		local card = deepcopy(LBP_DB[zone][subzone][id]);

		
		
		textbox:SetText(" ")
		--textbox:SetText(card["Name"].."\n\n");
		--print (GetSubZoneText());
		s = LBP:GetTalentString();
--[[			
		if card["Talents"] == s then
			textbox:SetText(textbox:GetText().."Talents: " .."|cff00FF00"..card["Talents"].."|r".."\n");
		else
			textbox:SetText(textbox:GetText().."Talents: " .."|cffFF0000"..card["Talents"].."|r".."\n");
			prepared = false;
		end
		--print("Talents: " ..s);
		
--]]
		

		if card["Spec"] == spec then
			textbox:SetText(textbox:GetText().."Spec: " .."|cff00FF00"..card["Spec"].."|r".."");
		else
			textbox:SetText(textbox:GetText().."Spec: " .."|cffFF0000"..card["Spec"].."|r".."");
			prepared = false;
		end
		--print("Spec: "..name);
		
		frame:SetTalents(card["Talents"])
		
		local g = LBP:GetGlyphTable(); -- die drin sind
		

		
		
		local copy = deepcopy(card["Glyphs"])-- Die drin sein sollen
		
		--for index,value in pairs(LBP_DB[subzone]["Glyphs"]) do
--			LBPMainframe:SetText(LBPMainframe:GetText()..LBP_DB[subzone]["Glyphs"][index].." "..index.."\n");
		--end

	
		-- berprfen welche richtig sind
		for index,value in pairs(g) do
			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(value[2])
			--frame.Glyph[index]:SetGlyph(icon, false)
			
			
			for index2 in pairs(copy) do
	
				if value[2] == tonumber(index2) then
					frame.Glyph[index]:SetGlyph(icon, true)
					frame.Glyph[index]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[index]); GameTooltip:SetSpellByID(value[2]); GameTooltip:Show(); end)
					frame.Glyph[index]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
					g[index] = 1;
					copy[index2] = {};
				end
			end		
	
		end
		
		for index,value in pairs(g) do
			if g[index] ~= 1 then
				for index2 in pairs(copy) do
					if copy[index2] == value[1] then
						local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(index2)
						frame.Glyph[index]:SetGlyph(icon, false)
						frame.Glyph[index]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[index]); GameTooltip:SetSpellByID(index2); GameTooltip:Show(); end)
						frame.Glyph[index]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
						copy[index2] = {};
						prepared = false;
						break
					end
				end
			end
		end

		
		if not card["Macro1"] then card["Macro1"] = "/script print(\"LBP: Macro #1\")"; end
		if not card["Macro2"] then card["Macro2"] = "/script print(\"LBP: Macro #2\")"; end
		if not card["Macro3"] then card["Macro3"] = "/script print(\"LBP: Macro #3\")"; end
		if not card["Macro4"] then card["Macro4"] = "/script print(\"LBP: Macro #4\")"; end
	
		local name, iconTexture, body = GetMacroInfo("LBP Macro 1");
			macroframe1:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe1:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro1"]); GameTooltip:Show(); end)
			macroframe1:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
			
		local name, iconTexture, body = GetMacroInfo("LBP Macro 2");
			macroframe2:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe2:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro2"]); GameTooltip:Show(); end)
			macroframe2:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)

		local name, iconTexture, body = GetMacroInfo("LBP Macro 3");
			macroframe3:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe3:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro3"]); GameTooltip:Show(); end)
			macroframe3:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)

		local name, iconTexture, body = GetMacroInfo("LBP Macro 4");
			macroframe4:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			macroframe4:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro4"]); GameTooltip:Show(); end)
			macroframe4:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)			
			
	end
	
		

	

	--print(GetTime().." OnUpdate")
    frame.timeUpdated = time();
  end

end	

	
	
	
	frame:SetScript("OnUpdate", function(self, event, ... ) OnUpdate(event, ...) end)
	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
	
		TimeSinceLastUpdate = UpdateFrequency;
		oldShow(...)
	end
	
	frame:Hide()
	return frame
end


function LBP.CreateWindow(self)
	local frame = LBP:CreateFrame("frame", "LBPMainFrame", UIParent, nil, "CENTER", UIParent, "CENTER", 0, 200, 300, 60)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:Show()
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, 0, 300, 50, "CENTER", "CENTER", 1, 1, 1, 1)
	
	local zone
	local subzone
	--if not frame.zone then frame.zone = GetZoneText() end
	--if not frame.subzone then frame.subzone = GetSubZoneText() end
	
	frame.cards ={}
	
	textbox:SetText("nhh")
	--textbox:Show()	
	
	function frame:SetText(msg)
		textbox:SetText(msg)
	end
	
	function frame:GetText()
		return textbox:GetText(msg)
	end
	

	
	frame.button = CreateFrame("BUTTON", "OkayNTC", frame, "UIPanelButtonTemplate")
		frame.button:SetText("X")
		frame.button:SetWidth(30)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
				showmode = false;
				frame:Hide()
			end)
		frame.button:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)
	

local OnUpdate = function(elapsed)										-- Beginn OnUpdate
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	
	
	
	if (TimeSinceLastUpdate > UpdateFrequency) then
		if not InCombatLockdown() and GetSubZoneText() ~= "" then
			
			
			if frame.zone ~= GetZoneText() or frame.subzone ~= GetSubZoneText() then
				frame.zone = GetZoneText()
				frame.subzone = GetSubZoneText()
				
				frame:SetText(frame.zone .."\n".. frame.subzone)

				local n = 0;
				if LBP_DB[GetZoneText()] then
					if LBP_DB[GetZoneText()][GetSubZoneText()] then
						for index,value in pairs(LBP_DB[GetZoneText()][GetSubZoneText()]) do
						
						
						if not LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro1"] then LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro1"] = "/script print(\"LBP Macro #1\")"; end
						if not LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro2"] then LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro2"] = "/script print(\"LBP Macro #2\")"; end
						if not LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro3"] then LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro3"] = "/script print(\"LBP Macro #3\")"; end
						if not LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro4"] then LBP_DB[GetZoneText()][GetSubZoneText()][index]["Macro4"] = "/script print(\"LBP Macro #4\")"; end
						
							n = n+1;
						end
					end
				end				
				
				for index,value in pairs(frame.cards) do
					value:Hide()
				end
				
				frame.cards = nil;
				frame.cards = {};
				
				if n>0 then
				a = 1;
					for index,value in pairs(LBP_DB[GetZoneText()][GetSubZoneText()]) do
						local tmpframe = LBP:CreateCard( frame, frame.zone, frame.subzone, index, n)
						
						tmpframe:SetPoint("TOP", frame, "BOTTOM", a*300-150-n*150, 0)

						tmpframe:Show()
						--local tmpframe = LBP:CreateFrame("frame", "Card", frame, nil, "TOP", frame, "BOTTOM", a*300-300, 0, 300, 150)
						--tmpframe:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });

						--tmpframe.textbox = LBP:CreateFontString(tmpframe, "textbox", "ARTWORK", "GameFontNormalLarge", "TOP", tmpframe, "TOP", 0, 0, 300, 50, "CENTER", "CENTER", 1, 1, 1, 1)
						--tmpframe.textbox:SetText(index)
						
						frame.cards[a] = tmpframe;
					
						a = a+1;
					end
				else
					if LBP_DB[GetZoneText()] then
						LBP_DB[GetZoneText()][GetSubZoneText()] = nil
					end
					frame:Hide()
				end
			end
			

		
			
			TimeSinceLastUpdate = 0;
		end
	end
	
end	

	
	
	
	frame:SetScript("OnUpdate", function(self, event, ... ) OnUpdate(event, ...) end)
	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		TimeSinceLastUpdate = UpdateFrequency;
		oldShow(...)
	end
	
	frame:Hide()
	return frame
end


function LBP.GetTalentString(self)
	s = "";
	for b = 0,5 do
		for a = 1,3 do
			local name, iconTexture, tier, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(b*3+a)
			if rank then s = s..a-1; end
			
	
		end
	end
	return s
end




function LBP.GetGlyphTable(self)
	local s = {};
	for b = 1,6 do
		local enabled, glyphType, glyphTooltipIndex, glyphSpell, icon = GetGlyphSocketInfo(b)
		--print(glyphSpell.." "..glyphType)
		s[b] = {glyphType, glyphSpell};
	end
	return s
end




function LBP.OnEvent( self, event, name, ...)
	if event=="UPDATE_MACROS" then
		local numglobal,numperchar = GetNumMacros();
		
		if numglobal > 32 then
			print("Nicht genug Platz fr die Macros")
		else
			if not GetMacroInfo("LBP Macro 1") then
				CreateMacro("LBP Macro 1", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #1\")", nil);
			end
			if not GetMacroInfo("LBP Macro 2") then
				CreateMacro("LBP Macro 2", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #2\")", nil);
			end
			if not GetMacroInfo("LBP Macro 3") then
				CreateMacro("LBP Macro 3", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #3\")", nil);
			end
			if not GetMacroInfo("LBP Macro 4") then
				CreateMacro("LBP Macro 4", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #4\")", nil);
			end
		end
	end
	if event=="VARIABLES_LOADED" then
		EventFrame:UnregisterEvent("ADDON_LOADED");
		
		LBPMainframe = LBP:CreateWindow();
		LBPConfigframe = LBP:CreateConfig();
		
		
		LBPMainframe:Hide()
		LBPConfigframe:Show()
		-- Macros

		
--		LBPOnUpdateframe = LBP:CreateFrame("frame", "LBPOnUpdateFrame", UIParent, nil, "TOPLEFT", UIParent, "TOPLEFT", 0, 0, 10, 10)
		--LBPOnUpdateframe:SetScript("OnUpdate", function(self, event, ... ) LBP:OnUpdate(event, ...) end)
	
	end
	
	if not InCombatLockdown() and LBPMainframe and not LBPConfigframe:IsVisible() then
		--LBPMainframe.zone = GetZoneText();
		--LBPMainframe.subzone = GetSubZoneText();
	
		LBPMainframe:Show()	
	end
end											

function LBP.OnUpdate(self, elapsed)										-- Beginn OnUpdate
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	

	while (TimeSinceLastUpdate > UpdateFrequency) do
	local zone = GetZoneText();
	local subzone = GetSubZoneText();
	
	if not LBP_DB[zone] then
		LBP_DB[zone] = {}
	end
  
	if GetSubZoneText() ~= "" and not LBP_DB[zone][subzone] then
		LBPOnUpdateframe:Hide()
	end
	if not InCombatLockdown() and GetSubZoneText() ~= "" then
		if LBP:Testing() then
			LBPMainframe:Hide()
			LBPOnUpdateframe:Hide()
		else
			LBPMainframe:Show()
		end
	end	
	if showmode then
		LBPOnUpdateframe:Show()
	end
	
	--print(GetTime().." OnUpdate")
			
    TimeSinceLastUpdate = TimeSinceLastUpdate - UpdateFrequency;
  end

end		

																-- Ende CreateFrame


function LBP.initialize(self)													-- Beginn initialize

	SlashCmdList["LBP"] = function( ) LBPMainframe:Hide() LBPConfigframe:Show() end
	SLASH_LBP1 = "/LBP";
	SLASH_LBP1 = "/lbp";
	
	EventFrame = CreateFrame( "Frame", "LBPEventframe", UIPARENT	)
	EventFrame:SetScript("OnEvent", function(self, event, ... ) LBP:OnEvent(event, ...) end)
	EventFrame:RegisterEvent("VARIABLES_LOADED");
	EventFrame:RegisterEvent("UPDATE_MACROS");
	EventFrame:RegisterEvent("ZONE_CHANGED");
	EventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	EventFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	--LBPObject = LBPLayoutObj()
	
						
	
	LBP:echo("LBP initialized...")

end	

-- Ende initialize


-- Hilfsfunktionen zum Erstellen von Frames

function LBP.CreateFrame(self, frameType, name, parent, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height)
	local frame = CreateFrame(frameType, name, parent, template);
	frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	frame:SetWidth(width);
	frame:SetHeight(height);
	
	return frame
end

function LBP.CreateFontString(self, frame, name, layer, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height, justifyH, justifyV, textColorR, textColorG, textColorB, textColorA)
	local fontstring = frame:CreateFontString(nil, layer, template)
		fontstring:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		fontstring:SetWidth(width)
		fontstring:SetHeight(height)
		fontstring:SetJustifyH(justifyH)
		fontstring:SetJustifyV(justifyV)
		fontstring:SetTextColor( textColorR, textColorG, textColorB, textColorA );
	
	return fontstring
end

LBP.initialize()




